//*****************************************************************/
//	T-7706LSRwK\tg	fp
//	Version:	1.0.0
//	CPU:		SH3-7706
//	Compiler:	MES
//	Histoy:		2011.12.06 ƊJn
//	
//	e
//	{^SW(4): ONɂLED_+LCD'*'\(10msSWmF+LCDXV)
//	gOSW(3): ONɃvXJE^[łA\7ZO
//				   (10msSWmF+1ms()7ZOړ)
//				   SW3+1ASW2+10ASW1+100܂
//				   SW310ɂȂƁASW30ɂSW2+1
//				   SW210ɂȂƁASW20ɂSW1+1
//				   SW110ɂȂƁASW10ɂ
//	ϒRVR(2): ADl0~10230~999LCDɕ\(500msLCDXV)
//
//
//	Written by Junichi Iwasaki
//	Last Modified 2011.12.07
//*****************************************************************/

#include <mes2.h>
#include <regdef.h>
#include <h8/reg770x.h>

#define IPRA_TMU0_MASK	0xf000
#define IPRA_TMU1_MASK	0x0f00
#define IPRA_TMU2_MASK	0x00f0
#define IPRA_TMU0_1	0x1000
#define IPRA_TMU1_1	0x0100
#define IPRA_TMU2_1	0x0010
#define TSTR_TMU0	0x01
#define TSTR_TMU1	0x02
#define TSTR_TMU2	0x04
#define TCR_UNF	0x0100

#define VECTOR_TUNI0	0x400
#define VECTOR_TUNI1	0x420
#define VECTOR_TUNI2	0x440

//////////////////////
/////  ֐錾  /////
//////////////////////
void _7Seg_Display(void);	// 7ZO\p
void LED_Display_SW(void);	// SWɂĂLED
void CntCtl_SW(void);		// gOSW̃JEgUP
void AD_get(void);		// VR1,VR2AD擾
void LCD_Display_SW(void);	// SW4~7LCD1sڂɕ\
void LCD_Display_AD(void);	// ADlLCD2sڂɕ\
void itobcd_3(int i,char *s);	//  -> (3p)

//////////////////////
//// GBLϐ錾  ////
//////////////////////
	int Cnt_10ms, Cnt_500ms, Cnt_100ms, Cnt_1s;		// ԃJEgp
	int cnt_sw1=0, cnt_sw2=0, cnt_sw3=0;	// eSW̃JEg
	//
	int fd,lcd_count;		// LCDʐMp
	int state_sw1,state_sw2,state_sw3,state_sw4;	// SWԎ擾p
	int state_tgl1,state_tgl2,state_tgl3;			// gOSWԎ擾p
	int old_tgl1,old_tgl2,old_tgl3;			// gOSW̑Ȍ

	// 7ZO\pf[^
	// 0x3f:"0" 0x06:"1" 0x5b:"2" 0x4f:"3" 0x66:"4" 0x6d:"5" 0x7d:"6" 0x27:"7"
	// 0x7f:"8" 0x67:"9" 0x77:"a" 0x7c:"b" 0x39:"c" 0x5e:"d" 0x79:"e" 0x71:"f"
	int const LED_SEG[16]= {0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x27,0x7f,0x67,0x77,0x7c,0x39,0x5e,0x79,0x71};
	int seg_ch1,seg_ch2,seg_ch3;
	int sw1,sw2,sw3,sw4;						// e|[g̃rbgʒu擾p
	int tgl1,tgl2,tgl3;
	int led1,led2,led3,led4;
	int seg_a,seg_b,seg_c,seg_d,seg_e,seg_f,seg_g,seg_dp;
	//
	int port_a,port_d,port_e,port_f,port_b,port_h;		// |[gAhX擾p
	int ad0_val,ad1_val;		// ADϊl擾p
	//
	IOREG *reg_sw1,*reg_sw2,*reg_sw3,*reg_sw4;
	IOREG *reg_tgl1,*reg_tgl2,*reg_tgl3;
	IOREG *reg_led1,*reg_led2,*reg_led3,*reg_led4;
	IOREG *reg_seg_ch1,*reg_seg_ch2,*reg_seg_ch3;
	IOREG *reg_seg_data;

// 荞݃nh(1msŊ)
void int_timer(void) __attribute__((interrupt_handler, nosave_low_regs));
void int_timer(void) {

	// MTU`lx̃Xe[^XNA
	TCR_2 &= ~TCR_UNF;
	// ԃJE^
	Cnt_500ms++;
	Cnt_10ms++;
	Cnt_100ms++;
	// 7ZO
	_7Seg_Display();
}

//////////////////////
////  C֐  ////
//////////////////////

int main()
{
// ^C}[荞ݗp
	// xN^4x0Ԃ̊荞݃nho^
	set_handler(VECTOR_TUNI2, int_timer);

	// TMU`lx荞݂̗D揇ʂ1ɐݒ
	IPRA &= ~IPRA_TMU2_MASK;
	IPRA |= IPRA_TMU2_1;
	// VXeNbN256ŃJEg/TMU`lx̊荞݋
	TCR_2 = 0x0023;
	// 1b 0.00000003125b(32MHz) X 256 X 125000 = 1b
	// 1ms 0.00000003125b(32MHz) X 256 X 125 = 1ms
	TCOR_2 = 125;
	TCNT_2 = 125;
	// TMU`lxN
	TSTR |= TSTR_TMU2;

	
	// |[gԍ擾
	port_a	= port2num("pta0");	// LCDf[^
	port_d	= port2num("ptd5");	// gOSW
	port_e	= port2num("pte5");	// LCD&LED
	port_f	= port2num("ptf0");	// ^NgSW
	port_b	= port2num("ptb0");	// 7ZOp
	port_h	= port2num("pth4"); // 7ZOp
	
	// ADϊ֘Aݒ
	STBCR	=  0	;
	STBCR2	=  0	;	// d̓[h
	PJCR	=  0	;	// |[gJɂ̑̋@\ݒ
	ADCSR	&= 0x71	;	// AN0,AN1I
	ADCSR	|= 0x11	;	// }`[h
	ADCR	=  0x07	;	// Rg[WX^ XL[hOFF
	ADCSR	|= 0x20	;	// ADϊJn
	
	// |[grbgʒu擾
	led1	= port2bit("ptf4");
	led2	= port2bit("pte5");
	led3	= port2bit("pte6");
	led4	= port2bit("pte7");
	tgl1	= port2bit("ptd5");
	tgl2	= port2bit("ptd6");
	tgl3	= port2bit("ptd7");
	sw1	= port2bit("ptf0");
	sw2	= port2bit("ptf1");
	sw3	= port2bit("ptf2");
	sw4	= port2bit("ptf3");
	seg_a	= port2bit("ptb0");
	seg_b	= port2bit("ptb1");
	seg_c	= port2bit("ptb2");
	seg_d	= port2bit("ptb3");
	seg_e	= port2bit("ptb4");
	seg_f	= port2bit("ptb5");
	seg_g	= port2bit("ptb6");
	seg_dp	= port2bit("ptb7");
	seg_ch1	= port2bit("pth4");
	seg_ch2	= port2bit("pth5");
	seg_ch3 = port2bit("pth6");

	// o͎w
	reg_led1	= get_dr(port_f); // eWX^̃AhX擾
	reg_led2	= get_dr(port_e);
	reg_led3	= get_dr(port_e);
	reg_led4	= get_dr(port_e);
	reg_sw1		= get_dr(port_f);
	reg_sw2		= get_dr(port_f);
	reg_sw3		= get_dr(port_f);
	reg_sw4		= get_dr(port_f);
	reg_tgl1	= get_dr(port_d);
	reg_tgl2	= get_dr(port_d);
	reg_tgl3	= get_dr(port_d);
	reg_seg_data= get_dr(port_b);
	reg_seg_ch1 = get_dr(port_h);
	reg_seg_ch2 = get_dr(port_h);
	reg_seg_ch3 = get_dr(port_h);
	
	ddr_set(port_f,1 << led1);	// o͎w
	ddr_set(port_e,1 << led2);
	ddr_set(port_e,1 << led3);
	ddr_set(port_e,1 << led4);
	ddr_reset(port_f,1 << sw1);	// ͎w
	ddr_reset(port_f,1 << sw2);
	ddr_reset(port_f,1 << sw3);
	ddr_reset(port_f,1 << sw4);
	ddr_reset(port_d,1 << tgl1);
	ddr_reset(port_d,1 << tgl2);
	ddr_reset(port_d,1 << tgl3);
	ddr_set(port_b,1 << seg_a);	// o͎w
	ddr_set(port_b,1 << seg_b);
	ddr_set(port_b,1 << seg_c);
	ddr_set(port_b,1 << seg_d);
	ddr_set(port_b,1 << seg_e);
	ddr_set(port_b,1 << seg_f);
	ddr_set(port_b,1 << seg_g);
	ddr_set(port_b,1 << seg_dp);
	ddr_set(port_h,1 << seg_ch1);
	ddr_set(port_h,1 << seg_ch2);
	ddr_set(port_h,1 << seg_ch3);

	// LCD\
	lcd_count=0;
	fd = open("lcd0", 0);
	fprintf(fd, "\033[2JT-7706LSR Demo.");
	fprintf(fd, "\033[2;1H");
	fprintf(fd, "Trinity LLC");
	sleep(3000);
	//
	fprintf(fd, "\033[1;1H");		// J[\1sڂ1ڂ
	fprintf(fd, "\033[2JS4  S5  S6  S7  ");	// Sʏĕ\
	fprintf(fd, "\033[2;1H");		// J[\2sڂ1ڂ
	fprintf(fd, "VR1=    VR2=");		// 2sڂ̕\

// C[v
	for(;;){
	// 10msSWǍ
		if (Cnt_10ms > 10) {
		// SWԓǂݍ
			state_sw1 = (*reg_sw1 >> sw1) & 1 ;
			state_sw2 = (*reg_sw2 >> sw2) & 1 ;
			state_sw3 = (*reg_sw3 >> sw3) & 1 ;
			state_sw4 = (*reg_sw4 >> sw4) & 1 ;
		// gOSWǂݍ
			state_tgl1= (*reg_tgl1>> tgl1)& 1;
			state_tgl2= (*reg_tgl2>> tgl2)& 1;
			state_tgl3= (*reg_tgl3>> tgl3)& 1;
		// LED_/
			LED_Display_SW();
		// JE^[
			CntCtl_SW();
		// LCD\
			LCD_Display_SW();	// SW\
		// tONA
			Cnt_10ms =0;
		}
	// ADϊ
		AD_get();
	// 500msADlLCD\
		if (Cnt_500ms > 500) {
		// LCD\
			LCD_Display_AD();	// AD\
			Cnt_500ms =0;		// tONA
		// LSRLED1̓_(1s)
			if (++Cnt_1s >1) {
				SCPDR ^= 0x10;
				Cnt_1s =0;
			}
		// fobN
		//	printf("sw1:%1d,sw2:%01d,sw3:%1d\r",cnt_sw1,cnt_sw2,cnt_sw3);
		}
	}	// for(;;)
	close(fd);
}	// main()

////////////////////////
///////// ֐ /////////
////////////////////////

//***************************************************
// @֐	void _7Seg_Display(void)
// @	Ȃ
// @ߒl	Ȃ
// @@\	7ZO\
// @l	
//***************************************************
void _7Seg_Display(void)
{
static int Digit=0;

	switch(Digit)
	{
		case 0:
    		Digit = 1;
			*reg_seg_data	= LED_SEG[cnt_sw1];
			//
			*reg_seg_ch1 |= 1 << seg_ch1;		// LED1_
			*reg_seg_ch2 &= ~(1 << seg_ch2)	;
			*reg_seg_ch3 &= ~(1 << seg_ch3)	;
    			break;
		case 1:
        	Digit = 2;
			*reg_seg_data	= LED_SEG[cnt_sw2];
			//
			*reg_seg_ch1 &= ~(1 << seg_ch1)	;
			*reg_seg_ch2 |= 1 << seg_ch2	;	// LED2_
			*reg_seg_ch3 &= ~(1 << seg_ch3)	;
			break;
		 case 2:
        	Digit = 3;
			*reg_seg_data	= LED_SEG[cnt_sw3];
			//
   			*reg_seg_ch1 &= ~(1 << seg_ch1)	;
			*reg_seg_ch2 &= ~(1 << seg_ch2)	;
			*reg_seg_ch3 |= 1 << seg_ch3	;	// LED3_
			break;
		case 3:
			Digit = 0;
   			*reg_seg_ch1 &= ~(1 << seg_ch1)	;	// SOFF
			*reg_seg_ch2 &= ~(1 << seg_ch2)	;
			*reg_seg_ch3 &= ~(1 << seg_ch3)	;
			break;
	}

}

//***************************************************
// @֐	void LED_Display_SW(void)
// @	Ȃ
// @ߒl	Ȃ
// @@\	SWɂĂLEDON/OFF
// @l	
//***************************************************
void LED_Display_SW(void)
{
	// SW1
	if (!state_sw1)
	{
		*reg_led1 |= 1 << led1;		// SW1_LED_
	}
	else
	{
		*reg_led1 &= ~(1 << led1);	// SW1_LED
	}
	// SW2
	if (!state_sw2)
	{
		*reg_led2 |= 1 << led2;		// SW2_LED_
	}
	else
	{
		*reg_led2 &= ~(1 << led2);	// SW2_LED
	}
	// SW3
	if (!state_sw3)
	{
		*reg_led3 |= 1 << led3;		// SW3_LED_
	}
	else
	{
		*reg_led3 &= ~(1 << led3);	// SW3_LED
	}
	// SW4
	if (!state_sw4) 
	{
		*reg_led4 |= 1 << led4;		// SW4_LED_
	}
	else
	{
		*reg_led4 &= ~(1 << led4);	// SW4_LED
	}
}

//***************************************************
// @֐	void CntCtl_SW(void)
// @	Ȃ
// @ߒl	Ȃ
// @@\	SW1`3ONŃJEgUP
// @l	
//***************************************************
void CntCtl_SW(void)
{
	// 1(SW3-LED3)
	if (state_tgl3 != old_tgl3) {
		if(!state_tgl3) {
			if (++cnt_sw3 >9) {			// 10Ȃ猅グ
				cnt_sw3 =0;
				if (++cnt_sw2 >9) {		// 10Ȃ猅グ
					cnt_sw2 =0;
					if (++cnt_sw1 >9) {	// 10Ȃ猅グ
						cnt_sw1 =0;
					}
				}
			}
		}
		old_tgl3 = state_tgl3;
	}
	// 2(SW2-LED2)
	if (state_tgl2 != old_tgl2) {
		if(!state_tgl2) {
			if (++cnt_sw2 >9) {			// 10Ȃ猅グ
				cnt_sw2 =0;
				if (++cnt_sw1 >9) {		// 10Ȃ猅グ
					cnt_sw1 =0;
				}
			}
		}
		old_tgl2 = state_tgl2;
	}
	// 3(SW1-LED1)
	if (state_tgl1 != old_tgl1) {
		if(!state_tgl1) {
			if (++cnt_sw1 >9) {			// 10Ȃ猅グ
				cnt_sw1 =0;
			}
		}
		old_tgl1 = state_tgl1;
	}
}

//***************************************************
// @֐	void AD_get(void)
// @	Ȃ
// @ߒl	Ȃ
// @@\	VR1,VR2AD擾
// @l	
//***************************************************
void AD_get(void)
{
int ad0_val_h,ad0_val_l;
int ad1_val_h,ad1_val_l;

	if(ADCSR && 0x80){	// ADϊtO`FbN
		ad0_val_h	= ADDRAH << 2	;
		ad0_val_l	= ADDRAL >> 6	;
		ad0_val		= ad0_val_h + ad0_val_l	;	// GBLϐ֑
		ad1_val_h	= ADDRBH << 2	;
		ad1_val_l	= ADDRBL >> 6	;
		ad1_val		= ad1_val_h + ad1_val_l	;	// GBLϐ֑
		// fobNo͗p
		//printf("ADCSR:%x,AD-DataA:%04d,AD-DataB:%04d\r",ADCSR,ad0_val,ad1_val);
		//
		ADCSR &= 0x7f	;	// ADϊtONA
		ADCSR |= 0x20	;	// ADϊĊJ
	}
}

//***************************************************
// @֐	void LCD_Display_SW(void)
// @	Ȃ
// @ߒl	Ȃ
// @@\	SW4~7LCD1sڂɕ\
// @l	
//***************************************************
void LCD_Display_SW(void)
{
static int old_sw1=0,old_sw2=0,old_sw3=0,old_sw4=0;		// LCD\p̑OSW

	if(state_sw1 != old_sw1) {
		fprintf(fd, "\033[1;3H");	// J[\1sڂ3ڂ
		if(!state_sw1) {
			write(fd, "*", 1);	// SW1ON\
		} else {
			write(fd, " ", 1);	// SW1OFF\
		}
	}
	if(state_sw2 != old_sw2) {
		fprintf(fd, "\033[1;7H");	// J[\1sڂ7ڂ
		if(!state_sw2) {
			write(fd, "*", 1);	// SW2ON\
		} else {
			write(fd, " ", 1);	// SW2OFF\
		}
	}
	if(state_sw3 != old_sw3) {
		fprintf(fd, "\033[1;11H");	// J[\1sڂ11ڂ
		if(!state_sw3) {
			write(fd, "*", 1);	// SW3ON\
		} else {
			write(fd, " ", 1);	// SW3OFF\
		}
	}
	if(state_sw4 != old_sw4) {
		fprintf(fd, "\033[1;15H");	// J[\1sڂ15ڂ
		if(!state_sw4) {
			write(fd, "*", 1);	// SW4ON\
		} else {
			write(fd, " ", 1);	// SW4OFF\
		}
	}
	//
	old_sw1 = state_sw1;
	old_sw2 = state_sw2;
	old_sw3 = state_sw3;
	old_sw4 = state_sw4;
}

//***************************************************
// @֐	void LCD_Display_AD(void)
// @	Ȃ
// @ߒl	Ȃ
// @@\	ADlLCD2sڂɕ\
// @l	ADl0`1023ALCD\0`999ɂ
//***************************************************
void LCD_Display_AD(void)
{
int ad_ch0, ad_ch1;
char str[5];
	
	// LCD\pϐ֑
	ad_ch0 = ad0_val * 0.977;	// W999/1023
	ad_ch1 = ad1_val * 0.977;
	// VR1\
	itobcd_3(ad_ch0,str);		// 3̕
	fprintf(fd, "\033[2;5H");	// J[\2sڂ5ڂ
	write(fd, str, 3);			// LCD\
	// VR2\
	itobcd_3(ad_ch1,str);		// 3̕
	fprintf(fd, "\033[2;13H");	// J[\2sڂ13ڂ
	write(fd, str, 3);			// LCD\
}

//***************************************************
// @֐	void itobcd_3(int i,char *s)
// @	ϊ鐔l, ϊ㕶ւ̃|C^
// @ߒl	Ȃ
// @@\	 -> (3p)
// @l	[TvXȂ
//***************************************************
void itobcd_3(int i,char *s)
{
	s[0]=i/100+'0'; i=i% 100;
	s[1]=i/10+'0';  i=i% 10;
	s[2]=i/1+'0';
	s[3]=0;
}


